C****                                                                   00010000
C**** Program PRO-FIT (ver.1.22) for individual profile fitting.        00020000
C**** The split-type Pearson VII and pseudo-Voigt functions             00030000
C****    are used to approximate profile shape.                         00040000
C**** This program was written by Hideo TORAYA in Nov. 1985,            00050000
C****    revised in Sep. 1987, and Sep. 1988.                           00060000
C**** No part of this program may be used without permission of author. 00070000
C**** Reference: J. Appl. cryst., vol.19, 440-447 (1986)                00080000
C****                                                                   00090000
      CHARACTER TIT*70                                                  00100000
C****                                                                   00110007
  101 FORMAT(A70)                                                       00120000
  211 FORMAT(                                                           00130000
     */' *************************************************************' 00140007
     */' * PPPPP  RRRRR   OOOO    FFFFFF II TTTTTTT Computer Program *' 00150007
     */' * P    P R    R O    O   F      II    T     for Individual  *' 00160007
     */' * PPPPP  RRRRR  O    O = FFFFF  II    T    Profile Fittings *' 00170007
     */' * P      R  R   O    O   F      II    T       (Ver. 1.22)   *' 00180007
     */' * P      R   R   OOOO    F      II    T       by H.TORAYA   *' 00190007
     */' *************************************************************')00200007
  212 FORMAT( ' *** The Computer Program PRO-FIT (ver.1.22) for pattern 00210000
     *decomposition **')                                                00220007
  221 FORMAT(//' Input job title in 70 characters.')                    00230000
  222 FORMAT(//' Select a print output mode for parameter changes.'     00240000
     * //5X,'0: no output,   1: output in each cycle.')                 00250007
  223 FORMAT(/5X,A70)                                                   00260000
  231 FORMAT(//' ********** Optimization was started **********')       00270000
  232 FORMAT(//' Select:'                                               00280000
     * //5X,'0: CRT display of fitting result,   1: no display.')       00290007
  241 FORMAT(//' Select'//4X,'-1: continue refinement,'                 00300000
     * /5X,'0: change the 2-theta range to be analyzed,'                00310007
     * /5X,'1: renew the intensity data,'/5X,'2: terminate job.')       00320007
  242 FORMAT(/' ********** End of single job ***************************00330000
     *****************')                                                00340007
  243 FORMAT(//' File name for print output = PROFIT OUT.')             00350000
C****                                                                   00360000
      NJOB=1                                                            00370000
      DRPF=0.0                                                          00380000
C**** OPEN(21,FILE='/PROFIT OUT',STATUS='UNKNOWN')                      00390001
   11 WRITE(*,211)                                                      00400000
      WRITE(*,221)                                                      00410000
      READ(*,101) TIT                                                   00420000
      WRITE(*,222)                                                      00430000
      READ(*,*) NCHA                                                    00440000
      WRITE(21,212)                                                     00450000
      WRITE(21,223) TIT                                                 00460000
      CALL DATAIN (NRSL)                                                00470000
   21 CALL PEAK (NRSL,NOBS)                                             00480000
   22 CALL CORECT (NOBS,IJOB,DRPF)                                      00490000
      IF(IJOB.LT.0) GO TO 41                                            00500000
      WRITE(*,231)                                                      00510000
      NRED=1                                                            00520000
      LCYL=0                                                            00530000
      NC=0                                                              00540000
   31 NC=NC+1                                                           00550000
      IF(NRED-1) 34,32,33                                               00560000
   32 CALL SELECT (NC,NRED,NVAR,NRSL)                                   00570000
      GO TO 34                                                          00580000
C****                                                                   00590008
   33 NRED=NRED-1                                                       00600000
   34 CALL REFLEX (LCYL,DRPF)                                           00610000
      CALL MATRIX (NC,LCYL,NOBS,NVAR,NCHA)                              00620000
      IF(LCYL.GT.1) GO TO 35                                            00630000
      CALL CHANGE (NC,LCYL,NVAR,NRED,NCHA)                              00640000
      IF(LCYL.GE.0) GO TO 31                                            00650000
   35 WRITE(*,232)                                                      00660000
      READ(*,*) ND                                                      00670000
      IF(ND.NE.0) GO TO 41                                              00680000
      CALL DISPLY (NOBS)                                                00690007
   41 WRITE(*,241)                                                      00700000
      READ(*,*) NJOB                                                    00710000
      IF(NJOB.GE.2) GO TO 42                                            00720000
      IF(NJOB) 22,21,11                                                 00730000
   42 WRITE(21,242)                                                     00740000
C**** CLOSE(21)                                                         00750007
      REWIND 21                                                         00760007
      WRITE(*,243)                                                      00770000
      STOP                                                              00780000
C****                                                                   00790008
      END                                                               00800000
C****                                                                   00810000
      SUBROUTINE SELECT (NC,NRED,NVAR,NRSL)                             00820000
C****                                                                   00830007
      COMMON/PSEL/IAUT,NAUT,IBG(5),IPP(15,6)                            00840000
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               00850000
C****                                                                   00860007
      DIMENSION JBG(5),JPP(5,6)                                         00870000
C****                                                                   00880007
      DATA JBG,JPP/1,0,0,0,0,                                           00890000
     *1,1,1,1,1, 1,1,1,1,1, 0,1,1,1,2, 0,0,1,0,2, 0,0,1,1,2, 0,0,1,9,2/ 00900007
C****                                                                   00910000
  211 FORMAT(//' ********** Parameter selection in the least squares cyc00920000
     *le of ',I2,' ********')                                           00930007
  212 FORMAT(/5X,'Select:'                                              00940000
     * //5X,'0: automatic refinement,   1: manual refinement.')         00950007
  213 FORMAT(/5X,'Input the following integers:'                        00960000
     * //7X,'n=0: for parameter to be fixed,'                           00970007
     *  /7X,'n=1: for parameter to be varied.'                          00980007
     * //5X,'For parameters b1, b2, b3, K, & e.')                       00990007
  214 FORMAT(/5X,'Input the following integers for the jth peak:'       01000000
     *//7X,'n=0: for parameter to be fixed,'                            01010007
     * /7X,'n=1: for parameter to be varied,'                           01020007
     * /7X,'n>1: for parameter to reset as Xj=Xj-(n-1),'                01030007
     * /7X,'n=9: for parameter Rh to reset as Rh=Rl.'/)                 01040007
  215 FORMAT( 5X,'For parameters I, T, W, A, Rl & Rh of',I2,'th peak.') 01050000
  216 FORMAT(/5X,'Read carefully the note once more.')                  01060000
  217 FORMAT(/' How many cycles do you repeat this parameter selection?'01070000
     *//5X,'Nc = -1: back to the beginning of selection,'               01080007
     * /5X,'Nc =  0: to the parameter convergence,'                     01090007
     * /5X,'Nc >  0: in n cycles,'                                      01100007
     * /5X,'Nc = 99: terminate after this cycle.')                      01110007
  218 FORMAT(/4X,'Parameter selections in cycle',I3/4X,'Nc =',I3,       01120000
     *  ',  Xb = ',5I2/4X,'Xp(j,1-6) =',4(2X,6I2)/15X,4(2X,6I2))        01130007
C****                                                                   01140000
      IF(NC.EQ.1) NAUT=1                                                01150000
      WRITE(*,211) NC                                                   01160000
      IF(NAUT.EQ.1) THEN                                                01170000
         WRITE(*,212)                                                   01180008
         READ(*,*) IAUT                                                 01190008
         NAUT=0                                                         01200008
      END IF                                                            01210000
      IF(IAUT.EQ.0) GO TO 21                                            01220000
   11 WRITE(*,213)                                                      01230000
      READ(*,*) (IBG(I),I=1,5)                                          01240000
      WRITE(*,214)                                                      01250000
      DO 14 I=1,NREF                                                    01260000
   12 WRITE(*,215) I                                                    01270000
      READ(*,*) (IPP(I,J),J=1,6)                                        01280000
      DO 13 J=1,6                                                       01290000
      IF(IPP(I,J).GE.0.AND.IPP(I,J).LE.I) GO TO 13                      01300000
      IF(J.EQ.6.AND.IPP(I,J).EQ.9) GO TO 13                             01310000
      WRITE(*,216)                                                      01320000
      WRITE(*,214)                                                      01330000
      GO TO 12                                                          01340000
C****                                                                   01350007
   13 CONTINUE                                                          01360000
   14 CONTINUE                                                          01370000
      WRITE(*,217)                                                      01380000
      READ(*,*) NRED                                                    01390000
      IF(NRED.LT.0) GO TO 11                                            01400000
      WRITE(*,218) NC,NRED,(IBG(I),I=1,5),((IPP(I,J),J=1,6),I=1,NREF)   01410000
      GO TO 31                                                          01420000
C****                                                                   01430000
   21 DO 22 I=1,5                                                       01440000
   22 IBG(I)=JBG(I)                                                     01450000
      DO 23 I=1,NREF                                                    01460000
      IF(NC.EQ.1) K=1                                                   01470000
      IF(NC.EQ.2) K=2                                                   01480000
      IF(NC.GT.2.AND.NRSL.GT.1) K=3                                     01490000
      IF(NC.GT.2.AND.NRSL.EQ.1) K=4                                     01500000
      IF(I .GT.1) K=5                                                   01510000
      DO 23 J=1,6                                                       01520000
      IPP(I,J)=JPP(K,J)                                                 01530000
   23 CONTINUE                                                          01540000
   31 N=0                                                               01550000
      DO 33 I=1,5                                                       01560000
      M=IBG(I)                                                          01570000
      IF(M) 33,33,32                                                    01580000
   32 N=N+1                                                             01590000
      IBG(I)=N                                                          01600000
   33 CONTINUE                                                          01610000
      DO 37 I=1,NREF                                                    01620000
      DO 37 J=1,6                                                       01630000
      M=IPP(I,J)                                                        01640000
      IF(M-1) 37,34,35                                                  01650000
   34 N=N+1                                                             01660000
      IPP(I,J)=N                                                        01670000
      GO TO 37                                                          01680000
C****                                                                   01690007
   35 IF(J.EQ.6.AND.M.EQ.9) GO TO 36                                    01700000
      IPP(I,J)=IPP(I-M+1,J)                                             01710000
      GO TO 37                                                          01720000
   36 IPP(I,6)=IPP(I,5)                                                 01730000
   37 CONTINUE                                                          01740000
      NVAR=N                                                            01750000
      RETURN                                                            01760000
C****                                                                   01770008
      END                                                               01780000
C****                                                                   01790000
      SUBROUTINE REFLEX (LCYL,DRPF)                                     01800000
C****                                                                   01810008
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               01820000
      COMMON/WAVE/RWVL,WVL1,PMAX,SCAL                                   01830000
      COMMON/CONS/DAG(15,7,2),DRP(15,2,2)                               01840000
C****                                                                   01850008
      DATA RAD,DEG,PAI/0.01745329252E0,57.29577951E0,3.141592654E0/     01860000
C****                                                                   01870000
  211 FORMAT(/2X,'The 2-theta range of P(x), in which P(x) > 0.',10X,   01880000
     * 'Tmax      T2-T1')                                               01890007
  212 FORMAT(5X,'For',I3,'th peak (K alpha 1):',F8.3,' to',F8.3)        01900000
  213 FORMAT(19X,                '(K alpha 2):',F8.3,' to',F8.3,2F11.6) 01910000
C****                                                                   01920000
      WRITE(*,211)                                                      01930000
      IF(LCYL.NE.0) WRITE(21,211)                                       01940000
      DO 33 I=1,NREF                                                    01950000
      R1=XPP(I,1)/(1.0+XBG(4))                                          01960000
      R2=XBG(4)*R1                                                      01970000
      TT=XPP(I,2)                                                       01980000
      FW=XPP(I,3)                                                       01990000
      AS=XPP(I,4)                                                       02000000
      RL=XPP(I,5)                                                       02010000
      RH=XPP(I,6)                                                       02020000
      ST=SIN(0.5*RAD*TT)                                                02030000
      IF(NSOD.GT.1) THEN                                                02040000
         ET=XBG(5)*TAN(0.5*RAD*TT)/WVL1                                 02050008
         DTT(I)=2.0*DEG*(ASIN(ST*RWVL)+ET)-TT                           02060008
      ELSE                                                              02070008
         DTT(I)=0.0                                                     02080008
      END IF                                                            02090000
      IF(NFNC-1) 11,21,21                                               02100000
C****                                                                   02110000
C**** Pearson VII function                                              02120000
C****                                                                   02130000
   11 CL=1.0/RL                                                         02140000
      CH=1.0/RH                                                         02150000
      EL=2.0**CL-1.0                                                    02160000
      EH=2.0**CH-1.0                                                    02170000
      DL=GAMMA(RL-0.5)/(SQRT(EL)*GAMMA(RL))                             02180000
      DH=GAMMA(RH-0.5)/(SQRT(EH)*GAMMA(RH))                             02190000
      GH=(1.0+AS)*(1.0+AS)                                              02200000
      GL=GH/(AS*AS)                                                     02210000
      QQ=AS*DL+DH                                                       02220000
      DAG(I,1,1)=GL*EL                                                  02230000
      DAG(I,1,2)=GH*EH                                                  02240000
      DAG(I,2,1)=1.128379167E0*(1.0+AS)/(QQ*FW)                         02250000
      DAG(I,2,2)=DAG(I,2,1)                                             02260000
      IF(LCYL.GT.0) GO TO 12                                            02270000
      DAG(I,3,1)=2.0*RL*GL*EL/FW                                        02280000
      DAG(I,3,2)=2.0*RH*GH*EH/FW                                        02290000
      DAG(I,4,1)=1.0/(1.0+AS)-DL/QQ                                     02300000
      DAG(I,4,2)=DAG(I,4,1)                                             02310000
      DAG(I,5,1)= 2.0*RL*EL*(1.0+AS)/(AS*AS*AS)                         02320000
      DAG(I,5,2)=-2.0*RH*EH*(1.0+AS)                                    02330000
      DS=1000.0                                                         02340000
      SL=RL+1.0/DS                                                      02350000
      SH=RH+1.0/DS                                                      02360000
      PL=1.0/SL                                                         02370000
      PH=1.0/SH                                                         02380000
      FL=2.0**PL-1.0                                                    02390000
      FH=2.0**PH-1.0                                                    02400000
      BL=GAMMA(SL-0.5)/(SQRT(FL)*GAMMA(SL))                             02410000
      BH=GAMMA(SH-0.5)/(SQRT(FH)*GAMMA(SH))                             02420000
      DAG(I,6,1)=-AS*DS*(BL-DL)/QQ                                      02430000
      DAG(I,6,2)=   -DS*(BH-DH)/QQ                                      02440000
      DAG(I,7,1)=ALOG(2.0)*GL*(EL+1.0)/RL                               02450000
      DAG(I,7,2)=ALOG(2.0)*GH*(EH+1.0)/RH                               02460000
   12 IF(R1.LE.0.0) GO TO 31                                            02470000
      P1=DAG(I,2,1)*R1/DRPF                                             02480000
      P2=DAG(I,2,1)*R2/DRPF                                             02490000
      DRP(I,1,1)=TT-FW*SQRT(P1**CL-1.0)/SQRT(DAG(I,1,1))                02500000
      DRP(I,1,2)=TT+FW*SQRT(P1**CH-1.0)/SQRT(DAG(I,1,2))                02510000
      IF(NSOD.EQ.1) GO TO 32                                            02520000
      DRP(I,2,1)=TT-FW*SQRT(P2**CL-1.0)/SQRT(DAG(I,1,1))+DTT(I)         02530000
      DRP(I,2,2)=TT+FW*SQRT(P2**CH-1.0)/SQRT(DAG(I,1,2))+DTT(I)         02540000
      GO TO 32                                                          02550000
C****                                                                   02560000
C**** pseudo-Voigt function                                             02570000
C****                                                                   02580000
   21 CL=RL+(1.0-RL)*1.475664627E0                                      02590000
      CH=RH+(1.0-RH)*1.475664627E0                                      02600000
      SS=2.0/(CL+AS*CH)                                                 02610000
      SL=CH*SS                                                          02620000
      SH=CL*SS                                                          02630000
      DH=(1.0+AS)/FW                                                    02640000
      DL=DH/AS                                                          02650000
      DAG(I,1,1)=DL**2                                                  02660000
      DAG(I,1,2)=DH**2                                                  02670000
      DAG(I,2,1)=DAG(I,1,1)*0.693147181E0                               02680000
      DAG(I,2,2)=DAG(I,1,2)*0.693147181E0                               02690000
      DA=(1.0+AS)/(PAI*FW)                                              02700000
      DAG(I,3,1)=SL*RL*DA                                               02710000
      DAG(I,3,2)=SH*RH*DA                                               02720000
      DB=(1.0+AS)*0.469718639E0/FW                                      02730000
      DAG(I,4,1)=SL*(1.0-RL)*DB                                         02740000
      DAG(I,4,2)=SH*(1.0-RH)*DB                                         02750000
      IF(LCYL.GT.0) GO TO 22                                            02760000
      DAG(I,5,1)=1.0/(1.0+AS)-0.5*SL                                    02770000
      DAG(I,5,2)=1.0/(1.0+AS)-0.5*SL                                    02780000
      DAG(I,6,1)=0.475664627E0/(CL+AS*CH)                               02790000
      DAG(I,6,2)=-DAG(I,6,1)*AS*CH/CL                                   02800000
      DAG(I,7,1)=-DAG(I,6,1)*CL/CH                                      02810000
      DAG(I,7,2)= DAG(I,6,1)*AS                                         02820000
   22 IF(R1.LE.0.0.OR.0.5*(RL+RH).LT.0.1) GO TO 31                      02830000
      AW=FW/(1.0+AS)                                                    02840000
      P1=DAG(I,3,1)/DRPF                                                02850000
      P2=DAG(I,3,2)/DRPF                                                02860000
      DRP(I,1,1)=TT-AS*AW*SQRT(R1*P1-1.0)                               02870000
      DRP(I,1,2)=TT+   AW*SQRT(R1*P2-1.0)                               02880000
      IF(NSOD.EQ.1) GO TO 32                                            02890000
      DRP(I,2,1)=TT-AS*AW*SQRT(R2*P1-1.0)+DTT(I)                        02900000
      DRP(I,2,2)=TT+   AW*SQRT(R2*P2-1.0)+DTT(I)                        02910000
      GO TO 32                                                          02920000
C****                                                                   02930000
   31 DRP(I,1,1)=TT-AS*4.0*FW/(1.0+AS)                                  02940000
      DRP(I,1,2)=TT+   4.0*FW/(1.0+AS)                                  02950000
      IF(NSOD.EQ.1) GO TO 32                                            02960000
      DRP(I,2,1)=TT-AS*4.0*FW/(1.0+AS)+DTT(I)                           02970000
      DRP(I,2,2)=TT+   4.0*FW/(1.0+AS)+DTT(I)                           02980000
   32 WRITE(*,212)  I,(DRP(I,1,K),K=1,2)                                02990000
      IF(NSOD.GT.1) WRITE(*,213)  (DRP(I,2,K),K=1,2)                    03000000
      IF(LCYL.EQ.0) GO TO 33                                            03010000
      T2=XPP(I,2)+DTT(I)                                                03020000
      WRITE(21,212) I,(DRP(I,1,K),K=1,2)                                03030000
      IF(NSOD.GT.1) WRITE(21,213) (DRP(I,2,K),K=1,2),T2,DTT(I)          03040000
   33 CONTINUE                                                          03050000
      RETURN                                                            03060000
C****                                                                   03070008
      END                                                               03080000
C****                                                                   03090000
      SUBROUTINE MATRIX (NC,LCYL,NOBS,NVAR,NCHA)                        03100000
C****                                                                   03110008
C**** Matrix inversion by modified Cholesky method                      03120000
C****                                                                   03130008
      DOUBLE PRECISION A,V,WA,WE,DIG                                    03140000
C****                                                                   03150008
      COMMON/CHNG/NRES,RMIN,PRWP,XVA(50),DIA(50)                        03160000
C****                                                                   03170008
      DIMENSION A(50,50),V(50),DIG(50)                                  03180000
      DIMENSION DER(50),RFC(31)                                         03190000
C****                                                                   03200000
  211 FORMAT(/2X,'Before cycle',I3,':   Rp =',F8.5,                     03210000
     *    ',   Rwp =',F8.5,',   Rp(peak) =',F8.5,'.')                   03220007
  212 FORMAT(/2X,'Variation in Rwp factor',4(/5X,8(F6.4,', ')))         03230000
  213 FORMAT(/2X,'After  cycle',I3,':   Rp =',F8.5,                     03240000
     *    ',   Rwp =',F8.5,',   Rp(peak) =',F8.5,'.')                   03250007
  221 FORMAT(/5X,'Matrix is singular for ii =',I3)                      03260000
C****                                                                   03270000
      IF(LCYL.GT.0) GO TO 12                                            03280000
      DO 11 I=1,NVAR                                                    03290000
      V(I)=0.0D0                                                        03300000
      DO 11 J=1,NVAR                                                    03310000
   11 A(I,J)=0.0D0                                                      03320000
   12 C1=0.0                                                            03330000
      C2=0.0                                                            03340000
      D1=0.0                                                            03350000
      D2=0.0                                                            03360000
      DO 17 N=1,NOBS                                                    03370000
      DO 13 I=1,NVAR                                                    03380000
   13 DER(I)=0.0                                                        03390000
      CALL YCALC (LCYL,N,YO,YC,YB,DER)                                  03400001
      IF(YO) 17,17,14                                                   03410000
   14 WG=1.0/YO                                                         03420000
      DY=YO-YC                                                          03430000
      C1=C1+ABS(DY)                                                     03440000
      C2=C2+WG*DY*DY                                                    03450000
      D1=D1+YO                                                          03460000
      DE=YO-YB                                                          03470000
      IF(DE.LT.0.0) DE=0.0                                              03480000
      D2=D2+DE                                                          03490000
      IF(LCYL) 17,15,17                                                 03500000
   15 DO 16 I=1,NVAR                                                    03510000
      DE=WG*DER(I)                                                      03520000
      WE=DE*DY                                                          03530000
      V(I)=V(I)+WE                                                      03540000
      DO 16 J=I,NVAR                                                    03550000
      WE=DE*DER(J)                                                      03560000
      A(I,J)=A(I,J)+WE                                                  03570000
   16 CONTINUE                                                          03580000
   17 CONTINUE                                                          03590000
      R1=C1/D1                                                          03600000
      R2=SQRT(C2/D1)                                                    03610000
      IF(ABS(D2).GT.1.0E-06) R3=C1/D2                                   03620009
      RN=NOBS-NVAR                                                      03630000
      SVAR=SQRT(C2/RN)                                                  03640000
      RFC(NC)=R2                                                        03650000
      PRWP=R2                                                           03660000
      IF(NC.EQ.1) RMIN=R2                                               03670000
      IF(R2.GT.RMIN) GO TO 21                                           03680000
      RMIN=R2                                                           03690000
      NRES=NC                                                           03700000
   21 IF(LCYL.GT.0) GO TO 22                                            03710000
      WRITE(*,211) NC,R1,R2,R3                                          03720000
      IF(NCHA.NE.0) WRITE(21,211) NC,R1,R2,R3                           03730000
      IF(R2.GT.0.1.AND.R2-RMIN.GT.0.100) GO TO 97                       03740000
      IF(R2.LE.0.1.AND.R2-RMIN.GT.0.050) GO TO 97                       03750000
      GO TO 41                                                          03760000
C****                                                                   03770008
   22 LCYL=2                                                            03780000
      MC=NC-1                                                           03790000
      WRITE(*,212) (RFC(I),I=1,NC)                                      03800000
      WRITE(*,213) MC,R1,R2,R3                                          03810000
      WRITE(21,212) (RFC(I),I=1,NC)                                     03820000
      WRITE(21,213) MC,R1,R2,R3                                         03830000
      GO TO 99                                                          03840000
C****                                                                   03850000
   41 IZ=0                                                              03860000
      DO 43 I=1,NVAR                                                    03870000
      IF(A(I,I)) 42,42,43                                               03880000
   42 IZ=IZ+1                                                           03890000
      WRITE(*,221) I                                                    03900000
      WRITE(21,221) I                                                   03910000
   43 CONTINUE                                                          03920000
      IF(IZ.NE.0) GO TO 98                                              03930000
      IF(NVAR.GT.1) GO TO 51                                            03940000
      DIA(1)=SNGL(1.0D0/DSQRT(A(1,1)))                                  03950001
      DIA(1)=SVAR*DIA(1)                                                03960000
      XVA(1)=SNGL(V(1)/A(1,1))                                          03970001
      GO TO 99                                                          03980000
C****                                                                   03990000
   51 DO 55 I=2,NVAR                                                    04000000
      WA=0.0D0                                                          04010000
      DO 52 K=1,I-1                                                     04020000
      DIG(K)=A(K,I)/A(K,K)                                              04030000
      WA=WA+DIG(K)*V(K)                                                 04040000
   52 CONTINUE                                                          04050000
      V(I)=V(I)-WA                                                      04060000
      DO 54 J=I,NVAR                                                    04070000
      WA=0.0D0                                                          04080000
      DO 53 K=1,I-1                                                     04090000
      WA=WA+DIG(K)*A(K,J)                                               04100000
   53 CONTINUE                                                          04110000
      A(I,J)=A(I,J)-WA                                                  04120000
   54 CONTINUE                                                          04130000
   55 CONTINUE                                                          04140000
      V(NVAR)=V(NVAR)/A(NVAR,NVAR)                                      04150000
      DO 62 K=1,NVAR-1                                                  04160000
      I=NVAR-K                                                          04170000
      WA=0.0D0                                                          04180000
      DO 61 J=I+1,NVAR                                                  04190000
      WA=WA+A(I,J)*V(J)                                                 04200000
   61 CONTINUE                                                          04210000
      V(I)=(V(I)-WA)/A(I,I)                                             04220000
   62 CONTINUE                                                          04230000
      DO 65 I=1,NVAR                                                    04240000
      A(I,I)=1.0D0/A(I,I)                                               04250000
      DO 64 J=I+1,NVAR                                                  04260000
      WA=0.0D0                                                          04270000
      DO 63 K=I,J-1                                                     04280000
   63 WA=WA+A(I,K)*A(K,J)                                               04290000
   64 A(I,J)=-WA/A(J,J)                                                 04300000
   65 CONTINUE                                                          04310000
      DO 67 I=1,NVAR                                                    04320000
      DO 67 J=I,NVAR                                                    04330000
      WA=0.0D0                                                          04340000
      DO 66 K=J,NVAR                                                    04350000
   66 WA=WA+A(I,K)*A(J,K)/A(K,K)                                        04360000
      A(I,J)=WA                                                         04370000
   67 CONTINUE                                                          04380000
      DO 71 I=1,NVAR                                                    04390000
      XVA(I)=SNGL(V(I))                                                 04400001
      DIA(I)=SNGL(DSQRT(A(I,I)))                                        04410001
   71 DIA(I)=SVAR*DIA(I)                                                04420000
      GO TO 99                                                          04430000
C****                                                                   04440000
   97 LCYL=-1                                                           04450000
      GO TO 99                                                          04460000
C****                                                                   04470008
   98 LCYL=-2                                                           04480000
   99 RETURN                                                            04490000
C****                                                                   04500008
      END                                                               04510000
C****                                                                   04520000
      SUBROUTINE YCALC (LCYL,N,YO,YC,YB,DER)                            04530001
C****                                                                   04540008
      COMMON/PSEL/IAUT,NAUT,IBG(5),IPP(15,6)                            04550000
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               04560000
      COMMON/CONS/DAG(15,7,2),DRP(15,2,2)                               04570000
      COMMON/YOBS/YOB(1501),RTT(1501)                                   04580000
      COMMON/YCAL/YCL(1501),YPE(15,1501)                                04590000
      COMMON/WAVE/RWVL,WVL1,PMAX,SCAL                                   04600000
C****                                                                   04610008
      DIMENSION DER(50)                                                 04620000
C****                                                                   04630008
      DATA RAD,DEG/0.01745329252E0,57.29577951E0/                       04640000
C****                                                                   04650000
      YO=YOB(N)                                                         04660000
      IF(YO) 91,91,11                                                   04670000
   11 TK=RTT(N)                                                         04680000
      RB=XBG(4)                                                         04690000
      RA=1.0/(1.0+RB)                                                   04700000
C**** FT=XBG(5)                                                         04710001
      YB=XBG(1)+XBG(2)*TK+XBG(3)*TK*TK                                  04720000
      IF(LCYL) 12,12,21                                                 04730000
   12 DO 17 I=1,3                                                       04740000
      M=IBG(I)                                                          04750000
      IF(M) 17,17,13                                                    04760000
   13 IF(I-2) 14,15,16                                                  04770000
   14 DER(M)=1.0                                                        04780000
      GO TO 17                                                          04790000
C****                                                                   04800008
   15 DER(M)=TK                                                         04810000
      GO TO 17                                                          04820000
C****                                                                   04830008
   16 DER(M)=TK*TK                                                      04840000
   17 CONTINUE                                                          04850000
   21 YP=0.0                                                            04860000
      DO 82 I=1,NREF                                                    04870000
      RI=XPP(I,1)                                                       04880000
      TT=XPP(I,2)                                                       04890000
      FW=XPP(I,3)                                                       04900000
      AS=XPP(I,4)                                                       04910000
      RL=XPP(I,5)                                                       04920000
      RH=XPP(I,6)                                                       04930000
      YPE(I,N)=0.0                                                      04940000
      DO 81 J=1,NSOD                                                    04950000
      IF(TK.LT.DRP(I,J,1).OR.TK.GT.DRP(I,J,2)) GO TO 81                 04960000
      YE=RI*RA                                                          04970000
      IF(J.EQ.2) THEN                                                   04980000
         TT=TT+DTT(I)                                                   04990008
         YE=YE*RB                                                       05000008
      ELSE                                                              05010000
         YPE(I,N)=YB                                                    05020008
      END IF                                                            05030000
      DK=TK-TT                                                          05040000
      K=1                                                               05050000
      IF(DK.GT.0.0) K=2                                                 05060000
      IF(NFNC-1) 31,51,51                                               05070000
C****                                                                   05080000
C**** Pearson VII function                                              05090000
C****                                                                   05100000
   31 DK=DK/FW                                                          05110000
      DD=DK*DK                                                          05120000
      FF=1.0+DAG(I,1,K)*DD                                              05130000
      RX=XPP(I,K+4)                                                     05140000
      DF=FF**RX                                                         05150000
      DF=DAG(I,2,K)/DF                                                  05160000
      YF=YE*DF                                                          05170000
      YP=YP+YF                                                          05180000
      YPE(I,N)=YPE(I,N)+YF                                              05190000
      IF(LCYL.GT.0) GO TO 81                                            05200000
      M=IBG(4)                                                          05210000
      IF(M) 33,33,32                                                    05220000
   32 DX=-YF*RA                                                         05230000
      IF(J.EQ.2) DX=-DX/RB                                              05240000
      DER(M)=DER(M)+DX                                                  05250000
   33 M=IBG(5)                                                          05260000
      IF(M.EQ.0.OR.J.EQ.1) GO TO 41                                     05270000
      DX=YF*DAG(I,3,K)*DK/FF                                            05280000
      ET=DEG*TAN(0.5*RAD*XPP(I,2))/WVL1                                 05290000
      DER(M)=DER(M)+DX*ET                                               05300000
   41 DO 49 L=1,6                                                       05310000
      M=IPP(I,L)                                                        05320000
      IF(M) 49,49,42                                                    05330000
   42 GO TO (43,44,45,46,47,47),L                                       05340000
C****                                                                   05350007
   43 IF(ABS(RI).GT.1.0E06) DX=YF/RI                                    05360007
      GO TO 48                                                          05370000
C****                                                                   05380007
   44 DX=YF*DAG(I,3,K)*DK/FF                                            05390000
      GO TO 48                                                          05400000
C****                                                                   05410007
   45 DX=YF*(DAG(I,3,K)*DD/FF-1.0/FW)                                   05420000
      GO TO 48                                                          05430000
C****                                                                   05440007
   46 DX=YF*(DAG(I,4,K)+DAG(I,5,K)*DD/FF)                               05450000
      GO TO 48                                                          05460000
C****                                                                   05470007
   47 DX=YF*DAG(I,6,L-4)                                                05480000
      IF(L.EQ.5.AND.K.EQ.2.OR.L.EQ.6.AND.K.EQ.1) GO TO 48               05490000
      DX=DX+YF*(-ALOG(FF)+DAG(I,7,K)*DD/FF)                             05500000
   48 DER(M)=DER(M)+DX                                                  05510000
   49 CONTINUE                                                          05520000
      GO TO 81                                                          05530000
C****                                                                   05540000
C**** pseudo-Voigt function                                             05550000
C****                                                                   05560000
   51 DD=DK*DK                                                          05570000
      FL=1.0+DAG(I,1,K)*DD                                              05580000
      FG=DAG(I,2,K)*DD                                                  05590000
      PL=DAG(I,3,K)/FL                                                  05600000
      IF(FG.GT.15.0) THEN                                               05610000
         PG=0.0                                                         05620008
      ELSE                                                              05630000
         PG=DAG(I,4,K)*EXP(-FG)                                         05640009
      END IF                                                            05650000
      YL=YE*PL                                                          05660000
      YG=YE*PG                                                          05670000
      YF=YL+YG                                                          05680000
      YP=YP+YF                                                          05690000
      YPE(I,N)=YPE(I,N)+YF                                              05700000
      IF(LCYL.GT.0) GO TO 81                                            05710000
      M=IBG(4)                                                          05720000
      IF(M) 53,53,52                                                    05730000
   52 DX=-YF*RA                                                         05740000
      IF(J.EQ.2) DX=-DX/RB                                              05750000
      DER(M)=DER(M)+DX                                                  05760000
   53 M=IBG(5)                                                          05770000
      IF(M.EQ.0.OR.J.EQ.1) GO TO 61                                     05780000
      DX=(YL/FL+YG*0.693147181E0)*2.0*DAG(I,1,K)*DK                     05790000
      ET=DEG*TAN(0.5*RAD*XPP(I,2))/WVL1                                 05800000
      DER(M)=DER(M)+DX*ET                                               05810000
   61 DO 71 L=1,6                                                       05820000
      M=IPP(I,L)                                                        05830000
      IF(M) 71,71,62                                                    05840000
   62 GO TO (63,64,65,66,67,68),L                                       05850000
   63 IF(ABS(RI).GT.1.0E-06) DX=YF/RI                                   05860007
      GO TO 69                                                          05870000
C****                                                                   05880008
   64 DX=(YL/FL+YG*0.693147181E0)*2.0*DAG(I,1,K)*DK                     05890000
      GO TO 69                                                          05900000
C****                                                                   05910008
   65 DX=(YL*(1.0-2.0/FL)+YG*(2.0*FG-1.0))/FW                           05920000
      GO TO 69                                                          05930000
C****                                                                   05940008
   66 DX=-2.0*(YL*(1.0-1.0/FL)+YG*FG)/(1.0+AS)                          05950000
      IF(K.EQ.1) DX=-DX/AS                                              05960000
      DX=DX+YF*DAG(I,5,K)                                               05970000
      GO TO 69                                                          05980000
C****                                                                   05990008
   67 DX=YF*DAG(I,6,K)                                                  06000000
      IF(K.EQ.1.AND.ABS(RL).GT.1.0E-06) DX=DX+YL/RL                     06010007
      IF(K.EQ.1.AND.ABS(RL-1.0).GT.1.0E-06) DX=DX-YG/(1.0-RL)           06020007
      GO TO 69                                                          06030000
C****                                                                   06040008
   68 DX=YF*DAG(I,7,K)                                                  06050000
      IF(K.EQ.2.AND.ABS(RH).GT.1.0E-06) DX=DX+YL/RH                     06060007
      IF(K.EQ.2.AND.ABS(RH-1.0).GT.1.0E-06) DX=DX-YG/(1.0-RH)           06070007
   69 DER(M)=DER(M)+DX                                                  06080000
   71 CONTINUE                                                          06090000
C****                                                                   06100000
   81 CONTINUE                                                          06110000
   82 CONTINUE                                                          06120000
      YC=YB+YP                                                          06130000
      YCL(N)=YC                                                         06140000
      GO TO 99                                                          06150000
C****                                                                   06160000
   91 YCL(N)=0.0                                                        06170000
      DO 92 I=1,NREF                                                    06180000
   92 YPE(I,N)=0.0                                                      06190000
   99 RETURN                                                            06200000
C****                                                                   06210008
      END                                                               06220000
C****                                                                   06230000
      SUBROUTINE CHANGE (NC,LCYL,NVAR,NRED,NCHA)                        06240000
C****                                                                   06250008
      CHARACTER HHP*2                                                   06260000
C****                                                                   06270008
      COMMON/PSEL/IAUT,NAUT,IBG(5),IPP(15,6)                            06280000
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               06290000
      COMMON/WAVE/RWVL,WVL1,PMAX,SCAL                                   06300000
      COMMON/CHNG/NRES,RMIN,PRWP,XVA(50),DIA(50)                        06310000
      COMMON/DUMP/DMP(11)                                               06320000
C****                                                                   06330008
      DIMENSION ABG(2,5),APP(2,15,6),SBG(5),SPP(15,6),HHP(11),ICL(2)    06340000
C****                                                                   06350008
      DATA HHP/'b1','b2','b3','K ','e ','I ','T ','W ','A ','Rl','Rh'/  06360000
      DATA RAD,DEG/0.01745329252E0,57.29577951E0/                       06370000
C****                                                                   06380000
  211 FORMAT(/2X,'Parameter changes in cycle',I3                        06390000
     * //5X,'No Para',11X,'Old',6X,'Change',9X,'New',6X,'e.s.d.')       06400007
  212 FORMAT(5X,3X,A2,4X,4F12.6)                                        06410000
  213 FORMAT(5X,I2,1X,A2,4X,4F12.6)                                     06420000
  221 FORMAT(/2X,'All parameters converge (change < 5% of e.s.d.) in the06430000
     * cycle of',I3,'.')                                                06440007
  222 FORMAT(/2X,'Rwp factor dose not change in the cycle of',I3,'.')   06450000
  223 FORMAT(/2X,'L.S. exceeds a preset number of cycles (25).')        06460000
  224 FORMAT(/2X,'L.S. was terminated by the user in the cycle of',     06470000
     * I3,'.')                                                          06480007
  225 FORMAT(//' Do you terminate the least-squares cycle ?')           06490000
  231 FORMAT(///' Parameters in this cycle is not of the least Rwp.'    06500000
     * /' Parameters in cycle',I3,' (Rwp=',F8.5,') have been reserved.' 06510007
     * /' Do you replace present parameters with them ?')               06520007
  241 FORMAT(/' !!! Parameters diverge.')                               06530000
  242 FORMAT(/' !!! Singular matrix.')                                  06540000
  243 FORMAT(//' Select:'                                               06550000
     * //5X,'0: continue with reserved parameters in the least Rwp,'    06560007
     *  /5X,'1: continue without changing the parameters,'              06570007
     *  /5X,'2: terminate the job.')                                    06580007
C****                                                                   06590000
      IF(LCYL.LT.0)  GO TO 61                                           06600000
      IF(NRES.NE.NC) GO TO 14                                           06610000
      DO 11 I=1,5                                                       06620000
      ABG(1,I)=XBG(I)                                                   06630000
   11 ABG(2,I)=SBG(I)                                                   06640000
      DO 12 I=1,NREF                                                    06650000
      DO 12 J=1,6                                                       06660000
      APP(1,I,J)=XPP(I,J)                                               06670000
   12 APP(2,I,J)=SPP(I,J)                                               06680000
C****                                                                   06690000
C**** ICON=1: parameters convergence, ICON=2: Rwp does not change.      06700000
C**** LCYL=1 is a sign for a last cycle of the least-squares            06710000
C****                                                                   06720000
   14 ICON=1                                                            06730000
      DO 15 I=1,NVAR                                                    06740000
      IF(ABS(XVA(I)).GT.0.05*DIA(I)) ICON=0                             06750000
   15 CONTINUE                                                          06760000
      IF(ICON.EQ.1) GO TO 16                                            06770000
      IF(NC.EQ.1) ICL(1)=0                                              06780000
      IMR2=INT(10000.0*PRWP)                                            06790001
      IMIN=INT(10000.0*RMIN)                                            06800001
      IF(PRWP-AINT(PRWP).GE.0.5) IMR2=IMR2+1                            06810000
      IF(RMIN-AINT(RMIN).GE.0.5) IMIN=IMIN+1                            06820000
      IF(IMIN.NE.ICL(2)) ICL(1)=0                                       06830000
      IF(IMR2.EQ.  IMIN) ICL(1)=ICL(1)+1                                06840000
      IF(ICL(1).EQ.3) ICON=2                                            06850000
      ICL(2)=IMIN                                                       06860000
      IF(NC  .GE.25) ICON=3                                             06870000
      IF(NRED.GE.99) ICON=4                                             06880000
   16 IF(ICON.GT. 0) LCYL=1                                             06890000
      IF(LCYL.EQ. 1) NRED=0                                             06900000
      WRITE(*,211) NC                                                   06910001
      IF(NCHA.NE.0) WRITE(21,211) NC                                    06920000
      DO 24 I=1,5                                                       06930000
      M=IBG(I)                                                          06940000
      IF(M) 23,23,22                                                    06950000
   22 PO=XBG(I)                                                         06960000
      PC=XVA(M)                                                         06970000
      PN=PO+PC*DMP(I)                                                   06980000
      PS=DIA(M)                                                         06990000
      XBG(I)=PN                                                         07000000
      SBG(I)=PS                                                         07010000
      WRITE(*,212) HHP(I),PO,PC,PN,PS                                   07020000
      IF(NCHA.NE.0) WRITE(21,212) HHP(I),PO,PC,PN,PS                    07030000
      GO TO 24                                                          07040000
C****                                                                   07050008
   23 SBG(I)=0.0                                                        07060000
   24 CONTINUE                                                          07070000
C****                                                                   07080000
      DO 34 I=1,NREF                                                    07090000
      DO 33 J=1,6                                                       07100000
      M=IPP(I,J)                                                        07110000
      IF(M) 32,32,31                                                    07120000
   31 PO=XPP(I,J)                                                       07130000
      PC=XVA(M)                                                         07140000
      PN=PO+PC*DMP(J+5)                                                 07150000
      PS=DIA(M)                                                         07160000
      XPP(I,J)=PN                                                       07170000
      SPP(I,J)=PS                                                       07180000
      WRITE(*,213) I,HHP(J+5),PO,PC,PN,PS                               07190000
      IF(NCHA.NE.0) WRITE(21,213) I,HHP(J+5),PO,PC,PN,PS                07200000
      GO TO 33                                                          07210000
C****                                                                   07220008
   32 SPP(I,J)=0.0                                                      07230000
   33 CONTINUE                                                          07240000
      ST=SIN(0.5*RAD*XPP(I,2))                                          07250000
      IF(NSOD.GT.1) THEN                                                07260000
         ET=XBG(5)*TAN(0.5*RAD*XPP(I,2))/WVL1                           07270008
         DTT(I)=2.0*DEG*(ASIN(ST*RWVL)+ET)-XPP(I,2)                     07280008
      ELSE                                                              07290008
         DTT(I)=0.0                                                     07300008
      END IF                                                            07310000
   34 CONTINUE                                                          07320000
      IF(LCYL.EQ.0) GO TO 99                                            07330000
      IF(ICON.EQ.1) WRITE(*,221) NC                                     07340000
      IF(ICON.EQ.2) WRITE(*,222) NC                                     07350000
      IF(ICON.EQ.3) WRITE(*,223)                                        07360000
      IF(ICON.EQ.4) WRITE(*,224) NC                                     07370000
      WRITE(*,225)                                                      07380000
      READ(*,*) ND                                                      07390000
      IF(ND.EQ.0) GO TO 51                                              07400000
      ICL(1)=0                                                          07410000
      LCYL=0                                                            07420000
      NRED=1                                                            07430000
      NAUT=1                                                            07440000
      GO TO 99                                                          07450000
C****                                                                   07460000
   51 IF(ICON.EQ.1) WRITE(21,221) NC                                    07470000
      IF(ICON.EQ.2) WRITE(21,222) NC                                    07480000
      IF(ICON.EQ.3) WRITE(21,223)                                       07490000
      IF(ICON.EQ.4) WRITE(21,224) NC                                    07500000
      IF(ICON.EQ.1.OR.NC.EQ.NRES) GO TO 54                              07510000
      WRITE(*,231) NRES,RMIN                                            07520000
      READ(*,*) ND                                                      07530000
      IF(ND.NE.0) GO TO 54                                              07540000
      DO 52 I=1,5                                                       07550000
      XBG(I)=ABG(1,I)                                                   07560000
   52 SBG(I)=ABG(2,I)                                                   07570000
      DO 53 I=1,NREF                                                    07580000
      DO 53 J=1,6                                                       07590000
      XPP(I,J)=APP(1,I,J)                                               07600000
   53 SPP(I,J)=APP(2,I,J)                                               07610000
   54 CALL OUTPUT (SBG,SPP)                                             07620000
      GO TO 99                                                          07630000
C****                                                                   07640000
   61 IF(LCYL.EQ.-1) WRITE(*,241)                                       07650000
      IF(LCYL.EQ.-2) WRITE(*,242)                                       07660000
      IF(LCYL.EQ.-1) WRITE(21,241)                                      07670000
      IF(LCYL.EQ.-2) WRITE(21,242)                                      07680000
      WRITE(*,243)                                                      07690000
      READ(*,*) ND                                                      07700000
      IF(ND-1) 62,65,99                                                 07710000
   62 DO 63 I=1,5                                                       07720000
      XBG(I)=ABG(1,I)                                                   07730000
   63 SBG(I)=ABG(2,I)                                                   07740000
      DO 64 I=1,NREF                                                    07750000
      DO 64 J=1,6                                                       07760000
      XPP(I,J)=APP(1,I,J)                                               07770000
   64 SPP(I,J)=APP(2,I,J)                                               07780000
      GO TO 66                                                          07790000
C****                                                                   07800008
   65 RMIN=PRWP                                                         07810000
   66 LCYL=0                                                            07820000
      NRED=1                                                            07830000
      NAUT=1                                                            07840000
C****                                                                   07850000
   99 RETURN                                                            07860000
      END                                                               07870000
C****                                                                   07880000
      SUBROUTINE OUTPUT (SBG,SPP)                                       07890000
C****                                                                   07900008
      CHARACTER HHP*2                                                   07910000
C****                                                                   07920008
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               07930000
      COMMON/WAVE/RWVL,WVL1,PMAX,SCAL                                   07940000
C****                                                                   07950008
      DIMENSION SBG(5),SPP(15,6),HHP(11)                                07960000
C****                                                                   07970008
      DATA HHP/'b1','b2','b3','K ','e ','I ','T ','W ','A ','Rl','Rh'/  07980000
C****                                                                   07990000
  221 FORMAT(/2X,'Final parameters optimized')                          08000000
  222 FORMAT(/6X,5(9X,A2)/6X,3F11.2,2F11.6/6X,3F11.2,2F11.6//5X,'Peak', 08010000
     * 7X,'I',7X,'Tmax',7X,'FWHM',7X,'Asym',6X,'Rl/el',6X,'Rh/eh')      08020007
  223 FORMAT(/4X,I2,F11.2,5F11.6/6X,F11.2,5F11.6)                       08030000
C****                                                                   08040000
      DO 21 I=1,3                                                       08050000
      XBG(I)=XBG(I)/SCAL                                                08060000
   21 SBG(I)=SBG(I)/SCAL                                                08070000
      WRITE(*,221)                                                      08080000
      WRITE(21,221)                                                     08090000
      WRITE(*,222)  (HHP(I),I=1,5),(XBG(I),I=1,5),(SBG(I),I=1,5)        08100000
      WRITE(21,222) (HHP(I),I=1,5),(XBG(I),I=1,5),(SBG(I),I=1,5)        08110000
      DO 22 I=1,NREF                                                    08120000
      RI=XPP(I,1)/SCAL                                                  08130000
      SI=SPP(I,1)/SCAL                                                  08140000
      WRITE(*,223)  I,RI,(XPP(I,J),J=2,6),SI,(SPP(I,J),J=2,6)           08150000
   22 WRITE(21,223) I,RI,(XPP(I,J),J=2,6),SI,(SPP(I,J),J=2,6)           08160000
      DO 23 I=1,3                                                       08170000
      XBG(I)=XBG(I)*SCAL                                                08180000
   23 SBG(I)=SBG(I)*SCAL                                                08190000
      RETURN                                                            08200000
C****                                                                   08210008
      END                                                               08220000
C****                                                                   08230000
      SUBROUTINE DATAIN (NRSL)                                          08240000
C****                                                                   08250008
C**** Input observed profile intensity data from file unit 11           08260000
C**** List of parameters.                                               08270000
C**** YOR(i): profile intensity data at the ith step.                   08280000
C**** SAMPLE: memorandom in 72 charaters.                               08290000
C**** NFOR  : data format, 0=10F7.0 (Toraya ver.), 1=8F8.0 (Young ver.).08300000
C**** NWVL  : radiation 0=Cu, 1=Cr, 2=Fe, 3=Co, 4=Mo, 5=Ag, 6=others,   08310000
C****   The following three data are required when NWVL=6.              08320000
C****   When 0 <= NWVL < 6, values in data statements are used.         08330000
C****   For synchrotron data, WVL1 is required, and WVL2=Ra12=0.        08340000
C**** WVL1  : wavelength of K alpha 1                                   08350000
C**** WVL2  : wavelength of K alpha 2                                   08360000
C**** RA12  : intensity ration of K alpha 2 to K alpha 1.               08370000
C**** TTRA  : the 2-theta of Y(1st  datum).                             08380000
C**** TTRB  : the 2-theta of Y(last datum).                             08390000
C**** STEP  : step interval of the data                                 08400000
C**** FIXT  : fixed counting time (not used in this program).           08410000
C****                                                                   08420008
      CHARACTER SAMPLE*70,FLNAME*20,HWL*2                               08430000
C****                                                                   08440008
      COMMON/WAVE/RWVL,WVL1,PMAX,SCAL                                   08450000
      COMMON/YDAT/RA12,TTRA,STEP,YOR(10001)                             08460000
C****                                                                   08470008
      DIMENSION HWL(7),DWL(6,3)                                         08480000
C****                                                                   08490008
      DATA HWL/'Cu','Cr','Fe','Co','Mo','Ag','  '/                      08500000
      DATA DWL/                                                         08510000
     *  1.540562, 2.289700, 1.936042, 1.788965, 0.709300, 0.5594075,    08520007
     *  1.544390, 2.293606, 1.939980, 1.792850, 0.713590, 0.563798,     08530007
     *  0.497,    0.515,    0.500,    0.497,    0.499,    0.499/        08540007
C****                                                                   08550000
  101 FORMAT(A20)                                                       08560000
  102 FORMAT(A70)                                                       08570000
  103 FORMAT(2I3,3F8.6,4F8.3)                                           08580000
  104 FORMAT(10F7.0)                                                    08590000
  105 FORMAT(8F8.0)                                                     08600000
  211 FORMAT(///' Input file name of intensity data by /****** DAT.')   08610000
  212 FORMAT(//'Select a resolution of Y(obs) data:'                    08620000
     * //5X,'-1: ultra-sharp,   0: sharp,   1: medium,   2: broad.')    08630007
  221 FORMAT(/' *********************** Profile intensity data *********08640000
     *****************'//2X,'Sample:',A70//5X,'File name = ',A20,       08650007
     * ',  2theta range =',F7.3,' - ',F7.3,','                          08660007
     * /5X,'Step width =',F6.3,',   Fixed time =',F6.1,                 08670007
     * ',   Y(obs)i points =',I6,'.'                                    08680007
     * /5X,'Y(obs)max =',F9.0,' at 2-theta =',F7.2,','                  08690007
     * /5X,'Y(obs)min =',F9.0,' at 2-theta =',F7.2,'.'                  08700007
     * /5X,'The data were normalized to Y(obs) = 100*Y(obs)/Y(obs)max.' 08710007
     * /5X,'Radiation = ',A2,',   Lambda =',F9.6,' &',F9.6,             08720007
     * ',  IKa2/IKa1 =',F6.3,'.')                                       08730007
C****                                                                   08740000
      WRITE(*,211)                                                      08750000
      READ(*,101) FLNAME                                                08760000
C**** OPEN(11,FILE=FLNAME,STATUS='OLD')                                 08770001
      REWIND(11)                                                        08780000
      READ(11,102) SAMPLE                                               08790000
      READ(11,103) NFOR,NWVL,WVL1,WVL2,RA12,TTRA,TTRB,STEP,FIXT         08800000
      IOBS=INT((TTRB-TTRA+0.001)/STEP+1.0)                              08810001
      IF(NFOR.EQ.0) READ(11,104) (YOR(I),I=1,IOBS)                      08820000
      IF(NFOR.NE.0) READ(11,105) (YOR(I),I=1,IOBS)                      08830000
C**** CLOSE(11)                                                         08840007
      REWIND 11                                                         08850007
      NWVL=NWVL+1                                                       08860000
      IF(NWVL.LT.7) THEN                                                08870000
         WVL1=DWL(NWVL,1)                                               08880008
         WVL2=DWL(NWVL,2)                                               08890008
         RA12=DWL(NWVL,3)                                               08900008
      END IF                                                            08910000
      RWVL=WVL2/WVL1                                                    08920000
      WRITE(*,212)                                                      08930000
      READ(*,*) NRSL                                                    08940000
      NRSL=NRSL+2                                                       08950000
      IF(NRSL.LT.1.OR.NRSL.GT.4) NRSL=2                                 08960000
      YOMX=0.0                                                          08970000
      YOMI=100000.0                                                     08980000
      DO 11 I=1,IOBS                                                    08990000
      YO=YOR(I)                                                         09000000
      IF(YO.GE.YOMX) THEN                                               09010000
         YOMX=YO                                                        09020008
         IX=I                                                           09030008
      END IF                                                            09040000
      IF(YO.LE.YOMI) THEN                                               09050000
         YOMI=YO                                                        09060008
         IN=I                                                           09070008
      END IF                                                            09080000
   11 CONTINUE                                                          09090000
      SCAL=100.0/YOMX                                                   09100000
      TTMX=TTRA+FLOAT(IX-1)*STEP                                        09110000
      TTMI=TTRA+FLOAT(IN-1)*STEP                                        09120000
      WRITE(*,221)  SAMPLE,FLNAME,TTRA,TTRB,STEP,FIXT,IOBS,             09130000
     * YOMX,TTMX,YOMI,TTMI,HWL(NWVL),WVL1,WVL2,RA12                     09140007
      WRITE(21,221) SAMPLE,FLNAME,TTRA,TTRB,STEP,FIXT,IOBS,             09150000
     * YOMX,TTMX,YOMI,TTMI,HWL(NWVL),WVL1,WVL2,RA12                     09160007
      RETURN                                                            09170000
C****                                                                   09180008
      END                                                               09190000
C****                                                                   09200000
      SUBROUTINE PEAK (NRSL,NOBS)                                       09210000
C****                                                                   09220008
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               09230000
      COMMON/WAVE/RWVL,WVL1,PMAX,SCAL                                   09240000
      COMMON/YDAT/RA12,TTRA,STEP,YOR(10001)                             09250000
      COMMON/YOBS/YOB(1501),RTT(1501)                                   09260000
C****                                                                   09270008
      DIMENSION NTP(30),RIN(30),TTH(30),FWH(3,4),DRA(4),ETA(4)          09280000
C****                                                                   09290008
      DATA FWH/ .0027,-.0009, .0020, .0108,-.0037, 0.0080,              09300000
     *          .0470,-.0660, .1230, .1880,-.2640, 0.4920/              09310007
      DATA DRA/ 2.5, 1.1, 1.2, 1.5/                                     09320000
      DATA ETA/ .50, .90, .80, .70/                                     09330000
      DATA RAD,DEG/0.01745329252E0,57.29577951E0/                       09340000
C****                                                                   09350000
      FCP(Y1,Y2,Y3)=Y2-0.125*(Y1-Y3)*(Y1-Y3)/(Y1-2.0*Y2+Y3)             09360000
      FCT(Y1,Y2,Y3,RT,SD)= RT+0.5*SD*(Y1-Y3)/(Y1-2.0*Y2+Y3)             09370000
C****                                                                   09380000
  211 FORMAT(/' ************************* Analysis conditions **********09390000
     *****************')                                                09400007
  212 FORMAT(//' Set a 2-theta range to be analyzed.'                   09410000
     *      //5X,'2-theta at  low angle side.')                         09420007
  213 FORMAT( 5X,'2-theta at high angle side.')                         09430000
  214 FORMAT(/5X,'Y(obs)i points =',I5,                                 09440000
     *  ',   Y(obs)max =',F9.0,',  Y(obs)min =',F7.0,','                09450007
     *      /5X,'2-theta range  =',F8.3,' -',F8.3,'.')                  09460007
  221 FORMAT(////' ********** Peak maximum positions **********'        09470000
     *   //5X,'No.',8X,'2-theta',4X,'Peak height')                      09480007
  222 FORMAT(5X,I2,9X,F7.3,8X,F7.3)                                     09490000
  223 FORMAT(/' Select (2-theta position of peak is of K alpha 1):'     09500000
     * /5X,'0: if the peak(s) in the table is just you wanted,'         09510007
     * /5X,'1: if there is the extra peak in the table,'                09520007
     * /5X,'2: if the table is needed to add further peak(s),'          09530007
     * /5X,'3: if you want to back once more to the peak hunting.')     09540007
  224 FORMAT(/' Select (Ka1) peak positions from the above table.'      09550000
     *  //5X,'Input the number from low angle side.'                    09560007
     *  //5X,'When you terminate the selection, input 0.'/' ')          09570007
  225 FORMAT(5X,'Nnumber = ')                                           09580000
  226 FORMAT(//' Input 2-theta value for an additional peak.'           09590000
     * //5X,'When you terminate the input, input 0.'/' ')               09600007
  227 FORMAT(5X,'2-theta for',I3,'th peak = ')                          09610000
  231 FORMAT(//' Select a profile function.'                            09620000
     *     //5X,'0: Pearson VII,   1: pseudo-Voigt.')                   09630007
  232 FORMAT(//' Select a profile shape modeling.'                      09640000
     * //5X,'0: Ka1+Ka2 doublet,   1: singlet.')                        09650007
  233 FORMAT(5X,'Profile function : Pearson VII.')                      09660000
  234 FORMAT(5X,'Profile function : pseudo-Voigt.')                     09670000
  235 FORMAT(5X,'Profile shape    : Ka1+Ka2 doublet.')                  09680000
  236 FORMAT(5X,'Profile shape    : singlet.')                          09690000
C****                                                                   09700000
      WRITE(*,211)                                                      09710000
      WRITE(21,211)                                                     09720000
      WRITE(*,212)                                                      09730000
      READ(*,*) TTHA                                                    09740000
      WRITE(*,213)                                                      09750000
      READ(*,*) TTHB                                                    09760000
      J=INT((TTHA-TTRA+0.0001)/STEP+1.0)                                09770001
      K=INT((TTHB-TTRA+0.0001)/STEP+1.0)                                09780001
      NOBS=K-J+1                                                        09790000
      N=0                                                               09800000
      PMAX=0.0                                                          09810000
      BAKL=100000.0                                                     09820000
      DO 11 I=J,K                                                       09830000
      N=N+1                                                             09840000
      RTT(N)=TTHA+STEP*FLOAT(N-1)                                       09850000
      YO=YOR(I)                                                         09860000
      YOB(N)=SCAL*YO                                                    09870000
      IF(YO.GT.PMAX) PMAX=YO                                            09880000
      IF(YO.LT.BAKL) BAKL=YO                                            09890000
   11 CONTINUE                                                          09900000
      WRITE(*,214)  NOBS,PMAX,BAKL,TTHA,TTHB                            09910000
      WRITE(21,214) NOBS,PMAX,BAKL,TTHA,TTHB                            09920000
C****                                                                   09930000
C**** Finding peak maximum positions                                    09940000
C****                                                                   09950000
      BGLV=SCAL*BAKL                                                    09960000
   21 SNRA=BGLV                                                         09970000
   22 N=0                                                               09980000
      RI=0.0                                                            09990000
      YX=YOB(1)-BGLV                                                    10000000
      YH=YOB(2)-BGLV                                                    10010000
      IF(YX.LT.0.0) YX=0.0                                              10020000
      IF(YH.LT.0.0) YH=0.0                                              10030000
      DO 29 I=3,NOBS                                                    10040000
      YL=YX                                                             10050000
      YX=YH                                                             10060000
      YH=YOB(I)-BGLV                                                    10070000
      IF(YH.LT.0.0) YH=0.0                                              10080000
      RI=RI+STEP*YX                                                     10090000
      IF(YX.LT.SNRA+BGLV)      GO TO 29                                 10100000
      IF(YX.LE.YL.OR.YX.LE.YH) GO TO 29                                 10110000
      N=N+1                                                             10120000
      IF(N-30) 23,24,24                                                 10130000
   23 RIN(N)=FCP(YL,YX,YH)                                              10140000
      TX=TTHA+STEP*FLOAT(I-2)                                           10150000
      TTH(N)=FCT(YL,YX,YH,TX,STEP)                                      10160000
      GO TO 29                                                          10170000
C****                                                                   10180008
   24 DO 26 J=1,10                                                      10190000
      RN=100000.0                                                       10200000
      DO 25 K=1,30                                                      10210000
      IF(ABS(RIN(K)).LE.1.0E-06.OR.RIN(K).GE.RN) GO TO 25               10220007
      RN=RIN(K)                                                         10230000
      IK=K                                                              10240000
   25 CONTINUE                                                          10250000
      RIN(IK)=0.0                                                       10260000
   26 CONTINUE                                                          10270000
      M=0                                                               10280000
      DO 28 J=1,30                                                      10290000
      IF(RIN(J)) 28,28,27                                               10300000
   27 M=M+1                                                             10310000
      RIN(M)=RIN(J)                                                     10320000
      TTH(M)=TTH(J)                                                     10330000
   28 CONTINUE                                                          10340000
      N=M                                                               10350000
   29 CONTINUE                                                          10360000
      NREF=N                                                            10370000
      IF(NREF.GT.0) GO TO 31                                            10380000
      SNRA=0.5*SNRA                                                     10390000
      IF(SNRA.LT.0.01*BGLV) GO TO 31                                    10400000
      GO TO 22                                                          10410000
C****                                                                   10420000
   31 WRITE(*,221)                                                      10430000
      DO 32 I=1,NREF                                                    10440000
   32 WRITE(*,222) I,TTH(I),RIN(I)                                      10450000
      WRITE(*,223)                                                      10460000
      READ(*,*) NS                                                      10470000
      IF(NS.GT.2) GO TO 21                                              10480000
      IF(NS-1) 51,33,41                                                 10490000
   33 WRITE(*,224)                                                      10500000
      M=0                                                               10510000
      DO 35 I=1,NREF                                                    10520000
   34 WRITE(*,225)                                                      10530000
      READ(*,*) NTP(I)                                                  10540000
      IF(NTP(I).LT.0.OR.NTP(I).GT.NREF) GO TO 34                        10550000
      IF(NTP(I).EQ.0) GO TO 36                                          10560000
      M=M+1                                                             10570000
   35 CONTINUE                                                          10580000
   36 NREF=M                                                            10590000
      DO 37 I=1,NREF                                                    10600000
      N=NTP(I)                                                          10610000
      TTH(I)=TTH(N)                                                     10620000
   37 RIN(I)=RIN(N)                                                     10630000
      GO TO 31                                                          10640000
C****                                                                   10650000
C**** Add peak positions to the table                                   10660000
C****                                                                   10670000
   41 WRITE(*,226)                                                      10680000
      DO 42 I=NREF+1,NREF+20                                            10690000
      WRITE(*,227) I                                                    10700000
      READ(*,*) TTH(I)                                                  10710000
      IF(ABS(TTH(I)).LE.1.0E-06) GO TO 43                               10720007
      N=INT((TTH(I)-TTHA)/STEP+1.0)                                     10730001
      RIN(I)=(YOB(N+1)-YOB(N))*(TTH(I)-RTT(N))/STEP+YOB(N)              10740000
   42 CONTINUE                                                          10750000
   43 NREF=I-1                                                          10760000
      DO 48 I=1,NREF                                                    10770000
   44 XI=RIN(I)                                                         10780000
      XT=TTH(I)                                                         10790000
      N=I                                                               10800000
      DO 45 J=I+1,NREF                                                  10810000
      IF(TTH(J).LT.XT) N=J                                              10820000
   45 CONTINUE                                                          10830000
      IF(N-I) 48,48,46                                                  10840000
   46 DO 47 J=I,N-1                                                     10850000
      RIN(J)=RIN(J+1)                                                   10860000
   47 TTH(J)=TTH(J+1)                                                   10870000
      RIN(N)=XI                                                         10880000
      TTH(N)=XT                                                         10890000
      GO TO 44                                                          10900000
C****                                                                   10910008
   48 CONTINUE                                                          10920000
      GO TO 31                                                          10930000
C****                                                                   10940000
   51 WRITE(*,231)                                                      10950000
      READ(*,*) NFNC                                                    10960000
      WRITE(*,232)                                                      10970000
      READ(*,*) NSOD                                                    10980000
      IF(NSOD.NE.0) NSOD=1                                              10990000
      IF(NSOD.EQ.0) NSOD=2                                              11000000
      IF(NFNC.EQ.0) WRITE(21,233)                                       11010000
      IF(NFNC.EQ.1) WRITE(21,234)                                       11020000
      IF(NSOD.EQ.2) WRITE(21,235)                                       11030000
      IF(NSOD.EQ.1) WRITE(21,236)                                       11040000
C****                                                                   11050000
C**** Preparation of initial values for the least-squares parameters    11060000
C**** Initial parameters used in this program is those for conventioanl 11070000
C****    X-ray and synchrotron radiation.   If you use this program for 11080000
C****    another sources, it is necessary to change these parameters.   11090000
C****                                                                   11100000
      XBG(1)=BGLV                                                       11110000
      XBG(2)=0.0                                                        11120000
      XBG(3)=0.0                                                        11130000
      XBG(4)=RA12                                                       11140000
      IF(NSOD.EQ.1) XBG(4)=0.0                                          11150000
      XBG(5)=0.0                                                        11160000
      PI=0.0                                                            11170000
      DO 61 I=1,NREF                                                    11180000
   61 PI=PI+RIN(I)                                                      11190000
      M=NREF/2                                                          11200000
      IF(M.EQ.0) M=1                                                    11210000
      TH=0.5*RAD*TTH(M)                                                 11220000
      TA=TAN(TH)                                                        11230000
      ST=SIN(TH)                                                        11240000
      FW=SQRT(FWH(1,NRSL)+FWH(2,NRSL)*TA+FWH(3,NRSL)*TA*TA)             11250000
      AS=1.0                                                            11260000
      IF(NRSL.EQ.1.OR.TTH(M).GT.90.0) GO TO 62                          11270000
      IF(TTH(M).GT.30.0) THEN                                           11280000
         AS=2.5-TTH(M)/60.0                                             11290008
      ELSE                                                              11300008
         AS=3.5-TTH(M)/20.0                                             11310008
      END IF                                                            11320000
   62 RD=DRA(NRSL)                                                      11330000
      IF(NFNC.NE.0) RD=ETA(NRSL)                                        11340000
      DO 63 I=1,NREF                                                    11350000
      XPP(I,1)=RI*RIN(I)/PI                                             11360000
      XPP(I,2)=TTH(I)                                                   11370000
      XPP(I,3)=FW                                                       11380000
      XPP(I,4)=AS                                                       11390000
      XPP(I,5)=RD                                                       11400000
      XPP(I,6)=RD                                                       11410000
      ST=SIN(0.5*RAD*TTH(I))                                            11420000
      IF(NSOD.GT.1) THEN                                                11430000
         ET=XBG(5)*TAN(0.5*RAD*XPP(I,2))/WVL1                           11440008
         DTT(I)=2.0*DEG*(ASIN(ST*RWVL)+ET)-XPP(I,2)                     11450008
      ELSE                                                              11460008
         DTT(I)=0.0                                                     11470008
      END IF                                                            11480000
   63 CONTINUE                                                          11490000
      RETURN                                                            11500001
C****                                                                   11510008
      END                                                               11520000
C****                                                                   11530000
      SUBROUTINE CORECT (NOBS,IJOB,DRPF)                                11540000
C****                                                                   11550008
      CHARACTER HPC*2                                                   11560000
C****                                                                   11570008
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               11580000
      COMMON/WAVE/RWVL,WVL1,PMAX,SCAL                                   11590000
      COMMON/DUMP/DMP(11)                                               11600000
C****                                                                   11610008
      DIMENSION DER(50),HPC(11)                                         11620000
C****                                                                   11630008
      DATA HPC/'b1','b2','b3','K ','e ','I ','T ','W ','A ','Rl','Rh'/  11640000
C****                                                                   11650000
  211 FORMAT(//' ********** Table of initial parameters **********'     11660000
     * //5X,'b1, b2 & b3: background parameters,'                       11670007
     *  /5X,'K : intensity ratio of Ka2 to Ka1,'                        11680007
     *  /5X,'e : correction for angular separation of Ka1 and Ka2,'     11690007
     *  /5X,'I : integrated intensity of the jth peak,'                 11700007
     *  /5X,'T : peak maximum position in 2-theta,'                     11710007
     *  /5X,'W : full-width at half-maximum (FWHM),'                    11720007
     *  /5X,'A : asymmetry defined by W(low angle side)/W(high),'       11730007
     *  /5X,'Rl: decay rate/eta parameter on  low angle side,'          11740007
     *  /5X,'Rh: decay rate/eta parameter on high angle side.')         11750007
  212 FORMAT(/10X,5(8X,A2)/10X,3F10.3,F10.4,F10.6//5X,'Peak ',6(8X,A2)) 11760000
  213 FORMAT(5X,I2,3X,F10.1,2F10.4,3F10.3)                              11770000
  214 FORMAT(//' Select:'//5X,'0: no correction,   1: correct table,   211780000
     *: see pattern,   3: end.')                                        11790007
  221 FORMAT(///' For correction of parameter value,'                   11800000
     * /5X,'input zero for no correction,'                              11810007
     * /5X,'input a new parameter value for the correction, and'        11820007
     * /5X,'input 0.00001 when new parameter is zero.'/)                11830007
  222 FORMAT( 5X,'Parameter ',A2,' =',F12.5,'  New parameter value = ') 11840000
  223 FORMAT(/5X,'For parameter ',A2)                                   11850000
  224 FORMAT( 8X,'of',I3,'th peak =',F12.5,', New parameter value = ')  11860000
  241 FORMAT(///' Select:'//5X,'0: no dumping for parameter change,'    11870000
     * /5X,'1: apply dumping factor.')                                  11880007
  242 FORMAT(/' Input dumping factor (default = 1).'/)                  11890000
  243 FORMAT(5X,'For ',A2,' parameter.   ? =')                          11900000
  244 FORMAT(/5X,'Dumping factor table:'/5X,11(4X,A2)/5X,11F6.3)        11910000
  251 FORMAT(//' I*P(x) is calculated for > I*P(x)limit.'//5X,'Input I*P11920000
     *(x)limit in counts (default =',F7.1,' counts).')                  11930007
  252 FORMAT(/5X,'I*P(x)limit = ',F9.1,' counts.' )                     11940000
C****                                                                   11950000
   11 DO 12 I=1,3                                                       11960000
   12 XBG(I)=XBG(I)/SCAL                                                11970000
      DO 13 I=1,NREF                                                    11980000
   13 XPP(I,1)=XPP(I,1)/SCAL                                            11990000
   14 WRITE(*,211)                                                      12000000
      WRITE(*,212) (HPC(I),I=1,5),(XBG(I),I=1,5),(HPC(I),I=6,11)        12010000
      DO 15 I=1,NREF                                                    12020000
   15 WRITE(*,213) I,(XPP(I,J),J=1,6)                                   12030000
      IJOB=1                                                            12040000
      WRITE(*,214)                                                      12050000
      READ(*,*) NCOR                                                    12060000
      IF(NCOR.EQ.1) GO TO 21                                            12070000
      IF(NCOR.GE.3) IJOB=-1                                             12080000
      DO 16 I=1,3                                                       12090000
   16 XBG(I)=XBG(I)*SCAL                                                12100000
      DO 17 I=1,NREF                                                    12110000
   17 XPP(I,1)=XPP(I,1)*SCAL                                            12120000
      IF(NCOR-2) 41,31,51                                               12130000
   21 WRITE(*,221)                                                      12140000
      DO 22 I=1,5                                                       12150000
      WRITE(*,222) HPC(I),XBG(I)                                        12160000
      READ(*,*) DP                                                      12170000
      IF(ABS(DP).LE.1.0E-06) GO TO 22                                   12180007
      IF(DP.LT.0.00002) DP=0.0                                          12190000
      XBG(I)=DP                                                         12200000
   22 CONTINUE                                                          12210000
      DO 23 J=1,6                                                       12220000
      WRITE(*,223) HPC(J+5)                                             12230000
      DO 23 I=1,NREF                                                    12240000
      WRITE(*,224) I,XPP(I,J)                                           12250000
      READ(*,*) DP                                                      12260000
      IF(ABS(DP).LE.1.0E-06) GO TO 23                                   12270007
      IF(DP.LT.0.00002) DP=0.0                                          12280000
      XPP(I,J)=DP                                                       12290000
   23 CONTINUE                                                          12300000
      GO TO 14                                                          12310000
C****                                                                   12320000
   31 DRPX=0.001*SCAL*PMAX                                              12330000
      CALL REFLEX (0,DRPX)                                              12340000
      DO 32 N=1,NOBS                                                    12350000
      CALL YCALC (1,N,YO,YC,YB,DER)                                     12360001
   32 CONTINUE                                                          12370000
      CALL DISPLY (NOBS)                                                12380007
      GO TO 11                                                          12390000
C****                                                                   12400000
   41 DO 42 I=1,11                                                      12410000
   42 DMP(I)=1.0                                                        12420000
      ND=1                                                              12430000
      WRITE(*,241)                                                      12440000
      READ(*,*) ND                                                      12450000
      IF(ND.EQ.0) GO TO 44                                              12460000
      WRITE(*,242)                                                      12470000
      DO 43 I=1,11                                                      12480000
      WRITE(*,243) HPC(I)                                               12490000
      READ(*,*) DMP(I)                                                  12500000
      IF(ABS(DMP(I)).LE.1.0E-06) DMP(I)=1.0                             12510007
   43 CONTINUE                                                          12520000
      WRITE(*,244)  (HPC(I),I=1,11),(DMP(I),I=1,11)                     12530000
      WRITE(21,244) (HPC(I),I=1,11),(DMP(I),I=1,11)                     12540000
   44 DRPF=DRPF/SCAL                                                    12550000
      IF(ABS(DRPF).LE.1.0E-06) DRPF=0.001*PMAX                          12560007
      WRITE(*,251) DRPF                                                 12570000
      READ(*,*) ER                                                      12580000
      IF(ABS(ER).GT.1.0E-06) DRPF=ER                                    12590007
      WRITE(*,252)  DRPF                                                12600000
      WRITE(21,252) DRPF                                                12610000
      DRPF=DRPF*SCAL                                                    12620000
   51 RETURN                                                            12630000
C****                                                                   12640008
      END                                                               12650000
C****                                                                   12660000
      SUBROUTINE DISPLY (NOBS)                                          12670002
C****                                                                   12680007
      COMMON/PARA/NREF,NFNC,NSOD,DTT(15),XBG(5),XPP(15,6)               12690002
      COMMON/YOBS/YOB(1501),RTT(1501)                                   12700002
      COMMON/YCAL/YCL(1501),YPE(15,1501)                                12710002
      COMMON/LGLN/MMXX,YDM(1501)                                        12720002
C****                                                                   12730008
      CHARACTER TEXTX2*13,TEXTY2*9                                      12740008
C****                                                                   12750007
      DIMENSION YYP(6001),TYP(6001),XLIM(2),YLIM(2),XTT(15),YTT(15)     12760002
C****                                                                   12770008
      DATA TEXTX2/'Scan position'/                                      12780008
      DATA TEXTY2/'Intensity'/                                          12790008
C****                                                                   12800007
C**** NREF          The number of reflections                           12810008
C**** NOBS          the number of observetions                          12820008
C**** RTT(i)        2-theta for ith step                                12830008
C**** YOB(i)        observed profile intensity                          12840008
C**** YCL(i)        calculated profile intensity                        12850008
C**** YPE(J,i)      Ycal for jth peak,                                  12860008
C**** XPP(J,2)      peak position for jth peak.                         12870008
C****                                                                   12880000
C**** This routine has been modified for the plotting package.  Comment 12890007
C**** has been added for the meaning of the plot calls as arrived in our12900007
C**** program bank. Original routines have been converted to the Calcomp12910007
C**** equivalents in order to get the same plot                         12920007
C****                                                                   12930007
C****                               S. Gorter   (ASKASG@HLERUL2)        12940007
C****                                                                   12950007
C****                       X-ray Diffraction Department                12960007
C****                       State University Leiden                     12970007
C****                            Netherlands                            12980007
C****                                                                   12990007
      YMIN=1000000.0                                                    13000002
      YMAX=0.0                                                          13010002
      DO 11 I=1,NOBS                                                    13020002
         IF(YOB(I).GT.YMAX) YMAX=YOB(I)                                 13030002
   11 CONTINUE                                                          13040002
      XLIM(1)=RTT(1)                                                    13050002
      XLIM(2)=RTT(NOBS)                                                 13060002
      YLIM(1)=-0.25*YMAX                                                13070002
      YLIM(2)=YMAX                                                      13080002
C****                                                                   13090004
C****   CALL PLOTS                                                      13100003
        CALL PLOTS(3)                                                   13110007
C****   Open plot file                                                  13120003
C****                                                                   13130004
C****   CALL PLOTCA (0.0,0.0,0.0)                                       13140003
        CALL PLOT(1.0,1.0,-3)                                           13150008
C****   Set first pen position                                          13160008
C****                                                                   13170004
C****   CALL PLOTCA (RTT(1),RTT(2))                                     13180003
C****   Set precision of data REAL*4, REAL*8 etc.                       13190003
C****   Not needed in Calcomp calls                                     13200008
C****                                                                   13210004
C****   CALL PLOTYS (10.0)                                              13220003
C****   Set length of y-axis. This call is replaced by the call to AXIS 13230008
C****   which not only sets the axis length but also plots tickmarks and13240008
C****   axis labels                                                     13250008
C****                                                                   13260004
C****   CALL PLOTSM (1,1,1,0.0,0.15,0.15)                               13270003
C****   Plotting symbols. Replaced by PLRAR for plotting symbols on the 13280008
C****   position of data points.                                        13290008
C****   Parameters:                                                     13300003
C****   1. 1           = number of symbol types to be set               13310003
C****   2. 1           = symbol (number or character) to be drawn       13320003
C****   3. 1           = plot symbol at every ksym-th point.            13330003
C****   4. 0.0         = fraction of overlap of symbols                 13340003
C****   5. 0.15        = symbol height in inches                        13350003
C****   6. 0.15        = line width for the symbol                      13360003
C****                                                                   13370004
C****   CALL PLOTLN (1,0.05,0.05,0.05,0.0)                              13380003
C****   Set line types                                                  13390003
C****   Parameters:                                                     13400003
C****   1. 1           = number of line types to be set                 13410003
C****   2. 0.05        = length of the first dash                       13420003
C****   3. 0.05        = length of space between dashes                 13430003
C****   4. 0.05        = length of the second dash                      13440003
C****   5. 0.0         = line width (0.0 = no line)                     13450003
C****                                                                   13460004
C****   CALL PLOTCA (RTT,YOB,NOBS,10.0,'2 THETA|','I (COUNTS)|',        13470003
C*****   XLIM,YLIM,0)                                                   13480007
C****   General plot call                                               13490003
C****   Parameters                                                      13500003
C****   1. RTT         = plot data in x-coordinate                      13510003
C****   2. YOB         = plot data in y-coordinate                      13520003
C****   3. NOBS        = number of points                               13530003
C****   4. 10.0        = length of plot in x-direction                  13540003
C****   5. '2 THETA|'  = label x-axis ('|' = terminating symbol)        13550003
C****   6. 'I (COUNTS)|'=label y-axis                                   13560003
C****   7. XLIM        = array containing min. and max. x-values        13570003
C****   8. YLIM        = array containing min. and max. y-values        13580003
C****   9. 0           = new plot, new scale                            13590003
C****                                                                   13600004
      CALL SCALE(RTT,6.0,96,1)                                          13610008
      FVALX=RTT(97)                                                     13620008
      DVX=RTT(98)                                                       13630008
      CALL SCALE(YOB,10.0,96,1)                                         13640008
      CALL LINE(RTT,YOB,96,1,-1,1)                                      13650009
      CALL AXIS(0.0,0.0,TEXTY2,9,10.0,90.0,FVALY,DVY)                   13660008
      CALL AXIS(0.0,0.0,TEXTX2,-13,6.0,0.0,FVALX,DVX)                   13670008
      MMXX=4*(NOBS-1)+1                                                 13680002
      TTEP=RTT(2)-RTT(1)                                                13690002
      DO 21 I=1,MMXX                                                    13700002
   21 TYP(I)=RTT(1)+0.25*TTEP*FLOAT(I-1)                                13710002
C****                                                                   13720004
C****   CALL PLOTCA (TYP(1),TYP(2))                                     13730004
C****   Set precision of data REAL*4, REAL*8 etc.                       13740004
C****                                                                   13750004
C****   CALL PLOTSM (1,1,1,0.0,0.0,0.0)                                 13760004
C****   Set symbol types, symbols on data points                        13770004
C****   1. 1           = number of symbol types to be set               13780004
C****   2. 1           = symbol (number or character) to be drawn       13790004
C****   3. 1           = plot symbol at every ksym-th point.            13800004
C****   4. 0.0         = fraction of overlap of symbols                 13810004
C****   5. 0.0         = symbol height in inches                        13820004
C****   6. 0.0         = line width for the symbol                      13830004
C****                                                                   13840004
C****   CALL PLOTLN (1,0.1,0.1,0.1,0.1)                                 13850004
C****   Set line types                                                  13860004
C****   Parameters:                                                     13870004
C****   1. 1           = number of line types to be set                 13880004
C****   2. 0.05        = length of the first dash                       13890004
C****   3. 0.05        = length of space between dashes                 13900004
C****   4. 0.05        = length of the second dash                      13910004
C****   5. 0.0         = line width (0.0 = no line)                     13920004
C****                                                                   13930004
      DO 24 I=1,NREF                                                    13940002
      DO 22 J=1,NOBS                                                    13950002
   22 YDM(J)=YPE(I,J)                                                   13960002
      DO 23 J=1,MMXX                                                    13970002
      K=(J-1)/4+1                                                       13980002
   23 YYP(J)=FCP4(J,K)                                                  13990002
C****                                                                   14000004
C****   CALL PLOTCA (TYP,YYP,MMXX,10.0,'|','|',XLIM,YLIM,-1)            14010004
C****   General plot call                                               14020004
C****   Parameters                                                      14030004
C****   1. TYP         = plot data in x-coordinate                      14040004
C****   2. YYP         = plot data in y-coordinate                      14050004
C****   3. MMXX        = number of points                               14060004
C****   4. 10.0        = length of plot in x-direction                  14070004
C****   5. '|'         = label x-axis ('|' = terminating symbol)        14080004
C****   6. '|'         = label y-axis                                   14090004
C****   7. XLIM        = array containing min. and max. x-values        14100004
C****   8. YLIM        = array containing min. and max. y-values        14110004
C****   9. -1          = old plot, old scale, no new axes or labels     14120004
C****                                                                   14130004
   24 CONTINUE                                                          14140002
      DO 25 I=1,NOBS                                                    14150002
   25 YDM(I)=YCL(I)                                                     14160002
      DO 26 I=1,MMXX                                                    14170002
      J=(I-1)/4+1                                                       14180002
   26 YYP(I)=FCP4(I,J)                                                  14190002
C****                                                                   14200004
C****   CALL PLOTLN (1,1.0,0.0,1.0,0.1)                                 14210004
C****   Set line types                                                  14220004
C****   Parameters:                                                     14230004
C****   1. 1           = number of line types to be set                 14240004
C****   2. 1.0         = length of the first dash                       14250004
C****   3. 0.0         = length of space between dashes                 14260004
C****   4. 1.0         = length of the second dash                      14270004
C****   5. 0.1         = line width (0.0 = no line)                     14280004
C****                                                                   14290004
C****   CALL PLOTCA (TYP,YYP,MMXX,10.0,'|','|',XLIM,YLIM,-1)            14300004
C****   General plot call                                               14310004
C****   Parameters                                                      14320004
C****   1. TYP         = plot data in x-coordinate                      14330004
C****   2. YYP         = plot data in y-coordinate                      14340004
C****   3. MMXX        = number of points                               14350004
C****   4. 10.0        = length of plot in x-direction                  14360004
C****   5. '|'         = label x-axis ('|' = terminating symbol)        14370004
C****   6. '|'         = label y-axis                                   14380004
C****   7. XLIM        = array containing min. and max. x-values        14390004
C****   8. YLIM        = array containing min. and max. y-values        14400004
C****   9. -1          = old plot, old scale, no new axes or labels     14410004
C****                                                                   14420004
      DO 27 I=1,NOBS                                                    14430002
   27 YYP(I)=YOB(I)-YCL(I)-0.125*YMAX                                   14440002
C****                                                                   14450004
C****   CALL PLOTLN (1,1.0,0.0,1.0,0.1)                                 14460004
C****   Set line types                                                  14470004
C****   Parameters:                                                     14480004
C****   1. 1           = number of line types to be set                 14490004
C****   2. 1.0         = length of the first dash                       14500004
C****   3. 0.0         = length of space between dashes                 14510004
C****   4. 1.0         = length of the second dash                      14520004
C****   5. 0.1         = line width (0.0 = no line)                     14530004
C****                                                                   14540004
C****   CALL PLOTCA (RTT,YYP,NOBS,10.0,'|','|',XLIM,YLIM,-1)            14550004
C****   General plot call                                               14560004
C****   Parameters                                                      14570004
C****   1. RTT         = plot data in x-coordinate                      14580004
C****   2. YYP         = plot data in y-coordinate                      14590004
C****   3. NOBS        = number of points                               14600004
C****   4. 10.0        = length of plot in x-direction                  14610004
C****   5. '|'         = label x-axis ('|' = terminating symbol)        14620004
C****   6. '|'         = label y-axis                                   14630004
C****   7. XLIM        = array containing min. and max. x-values        14640004
C****   8. YLIM        = array containing min. and max. y-values        14650004
C****   9. -1          = old plot, old scale, no new axes or labels     14660004
C****                                                                   14670004
      DO 29 I=1,NSOD                                                    14680002
      DO 28 J=1,NREF                                                    14690002
      IF(I.EQ.1) XTT(J)=XPP(J,2)                                        14700002
      IF(I.EQ.2) XTT(J)=XPP(J,2)+DTT(J)                                 14710002
   28 YTT(J)=-YMAX/25.0                                                 14720002
C****                                                                   14730005
C****   IF(I.EQ.1) CALL PLOTSM (1,79,1,0.0,0.25,0.20)                   14740004
C****   Set symbol types, symbols on data points                        14750004
C****   1. 1           = number of symbol types to be set               14760004
C****   2. 79   (O)    = symbol (number or character) to be drawn       14770005
C****   3. 1           = plot symbol at every ksym-th point.            14780004
C****   4. 0.0         = fraction of overlap of symbols                 14790004
C****   5. 0.25        = symbol height in inches                        14800005
C****   6. 0.20        = line width for the symbol                      14810005
C****                                                                   14820004
C****   IF(I.EQ.2) CALL PLOTSM (1,79,1,0.0,0.125,0.20)                  14830005
C****   Set symbol types, symbols on data points                        14840005
C****   1. 1           = number of symbol types to be set               14850005
C****   2. 79   (O)    = symbol (number or character) to be drawn       14860005
C****   3. 1           = plot symbol at every ksym-th point.            14870005
C****   4. 0.0         = fraction of overlap of symbols                 14880005
C****   5. 0.125       = symbol height in inches                        14890005
C****   6. 0.20        = line width for the symbol                      14900005
C****                                                                   14910005
C****   CALL PLOTLN (1,1.0,0.0,1.0,0.0)                                 14920005
C****   Set line types                                                  14930005
C****   Parameters:                                                     14940005
C****   1. 1           = number of line types to be set                 14950005
C****   2. 1.0         = length of the first dash                       14960005
C****   3. 0.0         = length of space between dashes                 14970005
C****   4. 1.0         = length of the second dash                      14980005
C****   5. 0.0         = line width (0.0 = no line)                     14990005
C****                                                                   15000005
C****   CALL PLOTCA (XTT,YTT,NREF,10.0,'|','|',XLIM,YLIM,-1)            15010005
C****   General plot call                                               15020005
C****   Parameters                                                      15030005
C****   1. XTT         = plot data in x-coordinate                      15040005
C****   2. YTT         = plot data in y-coordinate                      15050005
C****   3. NREF        = number of points                               15060005
C****   4. 10.0        = length of plot in x-direction                  15070005
C****   5. '|'         = label x-axis ('|' = terminating symbol)        15080005
C****   6. '|'         = label y-axis                                   15090005
C****   7. XLIM        = array containing min. and max. x-values        15100005
C****   8. YLIM        = array containing min. and max. y-values        15110005
C****   9. -1          = old plot, old scale, no new axes or labels     15120005
C****                                                                   15130005
   29 CONTINUE                                                          15140002
C****                                                                   15150005
C****   CALL PLOTCA (0.0,0.0,0.0)                                       15160005
C****   Close current plot file                                         15170005
      CALL PLOT(0.0,0.0,999)                                            15180008
      CALL ROUTE(0,0,0,0)                                               15190008
C****                                                                   15200005
      RETURN                                                            15210002
      END                                                               15220002
C****                                                                   15230000
      FUNCTION FCP4(J,K)                                                15240000
C****                                                                   15250005
      COMMON/LGLN/MMXX,YDM(1501)                                        15260000
C****                                                                   15270005
      L=4*(K-1)+1                                                       15280000
      P=0.25*(J-L)                                                      15290000
      J1=K-1                                                            15300000
      J2=K                                                              15310000
      J3=K+1                                                            15320000
      J4=K+2                                                            15330000
      IF(J2.EQ.   1) J1=1                                               15340000
      IF(J3.EQ.MMXX) J4=MMXX                                            15350000
      P1=-0.16666666667*P*(P-1)*(P-2)                                   15360000
      P2=       0.5*(P+1)*(P-1)*(P-2)                                   15370000
      P3=          -0.5*P*(P+1)*(P-2)                                   15380000
      P4= 0.16666666667*P*(P+1)*(P-1)                                   15390000
      FCP4=P1*YDM(J1)+P2*YDM(J2)+P3*YDM(J3)+P4*YDM(J4)                  15400000
      RETURN                                                            15410007
C****                                                                   15420005
      END                                                               15430000
